var wxBugTimer = null;
var wxBugTimerCmd = null;
var wxBugTimerAlert = null;
var wxBugTimerObs = null;
var wxBugTimerForecast = null;

const wxBugTimerInterval = 60000;
const wxBugDefaultInter = 300000;
var wxBugIsAlertDisplaying = false;
var wxBugGutsWin = null;

function wxBugMain() {
    wxBugSetPlacement();
	wxBugResetUi();
	wxBugResetLastUpdate();
	//if no location set to the default
	if (!wxBugUserHasLocation()) 
	{
	    wxBugSetCharPref( wxBugPrefZipCode, wxBugDefaultZipCode );
	    wxBugSetCharPref( wxBugPrefStationId, wxBugDefaultStationId );
	    wxBugSetCharPref( wxBugPrefUnits, '0' );
	    wxBugSetCharPref( wxBugPrefCityName, 'Mountain View' );
		wxBugSetCharPref( wxBugPrefState, 'CA' );
    }
	wxBugGetCmd();
}

function wxBugUnload() {
	//alert('unload');
}

function wxBugDocLoad(e) {
	var doc = e.originalTarget;
	var loc = doc.location;
        
	if (loc && loc.href && wxBugGutsWin) 
	{
		//wxBugLog('wxBugDocLoad: ' +  loc.href);
		if (loc.href.indexOf('http://weather.weatherbug.com') > -1) 
		{
		    wxBugGutsWin.close();
			//wxBugLog('wxBugDocLoad: Close');
			doc.focus();
		}	
	}
}

function wxBugOverlayClick(loc)
{
    alert(loc);
}

function wxBugLaunchOptions() {
	window.openDialog('chrome://weatherbug/content/weatherbugOptions.xul', 'weatherbugOptions', 'resizable,centerscreen,modal');
	wxBugUpdateOptions();
	
}

function wxBugLaunchLocationMgr() {
	window.openDialog('chrome://weatherbug/content/weatherbugLocation.xul', 'weatherbugLocation', 'resizable,centerscreen,modal');
	wxBugUpdateOptions();
	
}

function wxBugUpdateOptions() {
	//wxBugLog('wxBugUpdateOptions()');
	// kill the timer
	if (wxBugTimer) {
		clearTimeout(wxBugTimer);
	}
	
	//clear alert after options change
	if (wxBugIsActiveAlert()) wxBugClearActiveAlert();
	
	//reset last updates
	wxBugResetLastUpdate();
	
	//reset ui
	wxBugResetUi();
	
	//get new location specific urls
	wxBugGetCmd();
}

function wxBugUpdateLocationName() {
	// set location name tooltip
	var locTip = document.getElementById('wxBugLocationName');
	var locName = '';
	var city = wxBugGetCharPref(wxBugPrefCityName, '');
	if (city.length > 0) 
		locName += city;
	var state = wxBugGetCharPref(wxBugPrefState, '');
	if (state.length > 0)
		locName += ', ' + state;
	var country = wxBugGetCharPref(wxBugPrefCountry, '');
	if (country.length > 0)
		locName += ', ' + country;
	locTip.setAttribute('value', locName);
}

function wxBugLaunchContent() {
	var isOverlayEnabled = wxBugGetBoolPref (wxBugPrefOverlayEnabled, true) 
	if (isOverlayEnabled) {
		wxBugShowGuts();
	} 
	else {
		wxBugOpenInBrowser();
	}	
}

//Call this function to show the popup
function wxBugShowGuts() {
	wxBugGetObs();
	var anchor = document.getElementById('wxBugTemperature'); 
	var sX = anchor.boxObject.screenX;
	var sY = anchor.boxObject.screenY + anchor.boxObject.height;
	
	var width = wxBugGetIntPref(wxBugPrefWxWinWidth, defaultWidth);
	var height = wxBugGetIntPref(wxBugPrefWxWinHeight, defaultHeight);
	
	var flags = 'chrome,alwaysRaised=yes,dependent=yes,resizable=yes,width=' + width + ',height=' + height + ',screenX=' + sX + ',screenY=' + sY;
	wxBugGutsWin = window.open('chrome://weatherbug/content/weatherbugGutsWin.xul', 'wxBugGutsWin', flags);
	wxBugGutsWin.focus();
} 

function wxBugOpenInBrowser() {
	var url;
	
	if (wxBugIsActiveAlert()) {
		wxBugClearActiveAlert();
		url = wxBugGetCharPref(wxBugPrefWebWxAlert);
	} 
	else {
		url = wxBugGetCharPref(wxBugPrefWebWxLocal);
	}
		
	if (url) {	
		url = wxBugDeTokenizeUrl(url);
		wxBugLoadLink(url);
	    wxBugLog('wxBugOpenInBrowser: ' + url);
	}
}

function wxBugOnTimer() {
	wxBugLog('wxBugOnTimer()');
	
	if (wxBugTimer) {
		clearTimeout(wxBugTimer);
	}
	
	if (wxBugUserHasLocation()) {
		//wxBugLog('wxBugOnTimer() - has location');
		wxBugUpdateObs();
		wxBugUpdateAlert();
		wxBugUpdateForecast();
		wxBugTimer = setTimeout('wxBugOnTimer()', wxBugTimerInterval);
	}
}

